#property link      "diushych@nextmail.ru"
#property version   "1.02"
#property strict
#property indicator_chart_window

string lastDrawnTradeID = NULL;
extern string tradelevels = "== Lines =="; // 
extern color           Open_Color = clrYellowGreen;  //  
extern ENUM_LINE_STYLE Open_Style = STYLE_SOLID;     //  
extern int             Open_Width = 2;               //  
extern color           Stop_Color = clrOrangeRed;    //  
extern ENUM_LINE_STYLE Stop_Style = STYLE_SOLID;     //  
extern int             Stop_Width = 1;               //  
extern color           Take_Color = clrDodgerBlue;   //  
extern ENUM_LINE_STYLE Take_Style = STYLE_SOLID;     //  
extern int             Take_Width = 1;               //  
extern int             TradeLinesWidth = 50;         //   
extern color           TradeRectBGColor = Gainsboro;  //  -
extern int             TradeRectWidth = 40;          //   
extern string tradedescription = "== Label =="; // 
extern ENUM_BASE_CORNER tradedescription_Corner = CORNER_RIGHT_UPPER;
extern int X_Offset1 = 115;
extern int X_Offset2 = 125;
extern int Y_Offset = 15;
extern int Y_Spacing = 8;
extern ENUM_ALIGN_MODE AlignName = ALIGN_RIGHT;
extern ENUM_ALIGN_MODE AlignValue = ALIGN_LEFT;
extern int    Symbol_FontSize = 14;
extern string Symbol_FontName = "Arial";
extern color  Symbol_FontColor1 = clrGray;
extern color  Symbol_FontColor2 = clrSteelBlue;
extern int    OpenDate_FontSize = 14;
extern string OpenDate_FontName = "Arial";
extern color  OpenDate_FontColor1 = clrGray;
extern color  OpenDate_FontColor2 = clrSteelBlue;
extern int    OpenTime_FontSize = 14;
extern string OpenTime_FontName = "Arial";
extern color  OpenTime_FontColor1 = clrGray;
extern color  OpenTime_FontColor2 = clrSteelBlue;
extern int    CloseTime_FontSize = 14;
extern string CloseTime_FontName = "Arial";
extern color  CloseTime_FontColor1 = clrGray;
extern color  CloseTime_FontColor2 = clrSteelBlue;
extern int    Direction_FontSize = 14;
extern string Direction_FontName = "Arial";
extern color  Direction_FontColor1 = clrGray;
extern color  Direction_FontColor2 = clrSteelBlue;
extern int    ProfitLoss_FontSize = 14;
extern string ProfitLoss_FontName = "Arial";
extern color  ProfitLoss_FontColor1= clrGray;
extern color  ProfitLoss_FontColor2= clrSteelBlue;


extern int    TakeStopRatio_FontSize = 14;
extern string TakeStopRatio_FontName = "Arial";
extern color  TakeStopRatio_FontColor1 = clrGray;
extern color  TakeStopRatio_FontColor2 = clrSteelBlue;

extern int    TakeStopRatio1_FontSize = 14;
extern string TakeStopRatio1_FontName = "Arial";
extern color  TakeStopRatio1_FontColor1 = clrGray;
extern color  TakeStopRatio1_FontColor2 = clrSteelBlue;

extern bool   RemoveOriginalDotLine = true;
extern bool   RemoveOriginalArrows = true;
int offsetY, initialOffsetY, offsetX1, offsetX2;
ENUM_ANCHOR_POINT alignName, alignValue;
ENUM_BASE_CORNER corner;


void drawlabel(string name, string text, ENUM_ANCHOR_POINT textAnchor, int labelFontSize, color labelColor, string labelFontName, int X, int shift=0)
{
   if(shift != 0){
      shift += Y_Spacing;
      switch(corner)
      {
         case CORNER_LEFT_UPPER:  offsetY += shift; break;
         case CORNER_LEFT_LOWER:  offsetY -= shift; break;
         case CORNER_RIGHT_UPPER: offsetY += shift; break;
         case CORNER_RIGHT_LOWER: offsetY -= shift; break;
      }
   }
   ObjectCreate(0, name, OBJ_LABEL, 0, TimeCurrent(), 1);
   ObjectSetInteger(0, name, OBJPROP_CORNER, corner);
   ObjectSetInteger(0, name, OBJPROP_ANCHOR, textAnchor);
   ObjectSetInteger(0, name, OBJPROP_XDISTANCE, X);
   ObjectSetInteger(0, name, OBJPROP_YDISTANCE, offsetY);
   //ObjectSetInteger(0, name, OBJPROP_SELECTABLE, 0, false);
   ObjectSetInteger(0, name, OBJPROP_HIDDEN, 0, true);
   ObjectSetInteger(0, name, OBJPROP_FONTSIZE, labelFontSize);
   ObjectSetInteger(0, name, OBJPROP_COLOR, labelColor);
   ObjectSetString(0, name, OBJPROP_FONT, labelFontName);
   ObjectSetString(0, name, OBJPROP_TEXT, text);
}

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
{
//--- indicator buffers mapping
   ChartSetInteger(0, CHART_EVENT_OBJECT_CREATE, 1);
   ChartSetInteger(0, CHART_EVENT_OBJECT_DELETE, 1);
   int h = Y_Offset+Symbol_FontSize+OpenDate_FontSize+OpenTime_FontSize+CloseTime_FontSize+Direction_FontSize+ProfitLoss_FontSize+Y_Spacing*6;
   corner = tradedescription_Corner;
   switch(corner)
   {
      case CORNER_LEFT_UPPER:
        alignName  = AlignName == ALIGN_LEFT ? ANCHOR_LEFT_UPPER : ANCHOR_RIGHT_UPPER;
        alignValue = AlignValue == ALIGN_LEFT ? ANCHOR_LEFT_UPPER : ANCHOR_RIGHT_UPPER;
        initialOffsetY = 15; offsetX1 = X_Offset1; offsetX2 = X_Offset2; break;
      case CORNER_LEFT_LOWER:
        alignName  = AlignName == ALIGN_LEFT ? ANCHOR_LEFT_LOWER : ANCHOR_RIGHT_LOWER;
        alignValue = AlignValue == ALIGN_LEFT ? ANCHOR_LEFT_LOWER : ANCHOR_RIGHT_LOWER;
        initialOffsetY = h;  offsetX1 = X_Offset1; offsetX2 = X_Offset2; break;
      case CORNER_RIGHT_UPPER:
        alignName  = AlignName == ALIGN_LEFT ? ANCHOR_LEFT_UPPER : ANCHOR_RIGHT_UPPER;
        alignValue = AlignValue == ALIGN_LEFT ? ANCHOR_LEFT_UPPER : ANCHOR_RIGHT_UPPER;
        initialOffsetY = 15; offsetX1 = X_Offset2; offsetX2 = X_Offset1; break;
      case CORNER_RIGHT_LOWER:
        alignName  = AlignName == ALIGN_LEFT ? ANCHOR_LEFT_LOWER : ANCHOR_RIGHT_LOWER;
        alignValue = AlignValue == ALIGN_LEFT ? ANCHOR_LEFT_LOWER : ANCHOR_RIGHT_LOWER;
        initialOffsetY = h;  offsetX1 = X_Offset2; offsetX2 = X_Offset1; break;
   }
//---
   return(INIT_SUCCEEDED);
}
void OnDeinit(const int reason)
{
   ChartSetInteger(0, CHART_EVENT_OBJECT_CREATE, 0);
   ChartSetInteger(0, CHART_EVENT_OBJECT_DELETE, 0);
   ClearTradeDetails(lastDrawnTradeID);
}
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
{
//---
   
//--- return value of prev_calculated for next call
   return(rates_total);
}
//+------------------------------------------------------------------+
//| ChartEvent function                                              |
//+------------------------------------------------------------------+
void OnChartEvent(const int id,
                  const long &lparam,
                  const double &dparam,
                  const string &sparam)
{
//---
   if(id==CHARTEVENT_OBJECT_CREATE)
   {
      if(ObjectType(sparam) == OBJ_TREND && StringGetChar(sparam, 0) == '#')
      {
         DrawTradeDetails(sparam);
         if(RemoveOriginalDotLine)
         {
            ChartSetInteger(0, CHART_EVENT_OBJECT_DELETE, 0);
            ObjectDelete(sparam);
            ChartSetInteger(0, CHART_EVENT_OBJECT_DELETE, 1);
         }
      }
      if(ObjectType(sparam) == OBJ_ARROW && StringGetChar(sparam, 0) == '#' && getTradeID(sparam) != "")
      {
         if(RemoveOriginalArrows)
         {
            ChartSetInteger(0, CHART_EVENT_OBJECT_DELETE, 0);
            ObjectDelete(sparam);
            ChartSetInteger(0, CHART_EVENT_OBJECT_DELETE, 1);
         }
      }
   }
   else if(id==CHARTEVENT_OBJECT_DELETE)
   {
      if(StringFind(sparam, lastDrawnTradeID) == 0)
         ClearTradeDetails(getTradeID(sparam));
   }
}
//+------------------------------------------------------------------+

string getTradeID(string  sTradeID)
{
   int len = StringFind(sTradeID, " ");
   if(len<0)
   {
      return "";
   }
   sTradeID = StringSubstr(sTradeID, 0, len);
   return sTradeID;
}

string orderType2Str(int type)
{
   string direction;
   switch(type)
   {
      case OP_BUY: direction = "Buy"; break;
      case OP_BUYLIMIT: direction = "Buy limit"; break;
      case OP_BUYSTOP: direction = "Buy stop"; break;
      case OP_SELL: direction = "Sell"; break;
      case OP_SELLLIMIT: direction = "Sell limit"; break;
      case OP_SELLSTOP: direction = "Sell stop"; break;
   }
   return direction;
}






string StopExitRatio()
{
   if(OrderTakeProfit() != 0 && OrderStopLoss() != 0)
   {
      return DoubleToStr((OrderOpenPrice()-OrderClosePrice())/(OrderStopLoss()-OrderOpenPrice()), 2);
   }
   return "0";
}



string StopTakeRatio()
{
   if(OrderTakeProfit() != 0 && OrderStopLoss() != 0)
   {
      return DoubleToStr(fabs(OrderTakeProfit()-OrderOpenPrice())/fabs(OrderStopLoss()-OrderOpenPrice()), 2);
   }
   return "0";
}






void DrawTradeDetails(string trendLineName)
{
   string sTradeID = getTradeID(trendLineName);
   if(sTradeID != "")
   {
      int ticket = (int)StringToInteger(StringSubstr(sTradeID, 1));
      if(ticket>0 && OrderSelect(ticket, SELECT_BY_TICKET))
      {
         ClearTradeDetails(lastDrawnTradeID);
         //draw routine
         offsetY = initialOffsetY;
         
         drawlabel(sTradeID+" Symbol_N", ":", alignName, Symbol_FontSize, Symbol_FontColor1, Symbol_FontName, offsetX1, 0);
         drawlabel(sTradeID+" Symbol_V", OrderSymbol(), alignValue, Symbol_FontSize, Symbol_FontColor2, Symbol_FontName, offsetX2);
         drawlabel(sTradeID+" OpenDate_N", ":", alignName, OpenDate_FontSize, OpenDate_FontColor1, OpenDate_FontName, offsetX1, Symbol_FontSize);
         drawlabel(sTradeID+" OpenDate_V", TimeToString(OrderOpenTime(), TIME_DATE), alignValue, OpenDate_FontSize, OpenDate_FontColor2, OpenDate_FontName, offsetX2);
         drawlabel(sTradeID+" OpenTime_N", " :", alignName, OpenTime_FontSize, OpenTime_FontColor1, OpenTime_FontName, offsetX1, OpenDate_FontSize);
         drawlabel(sTradeID+" OpenTime_V", TimeToString(OrderOpenTime(), TIME_MINUTES|TIME_SECONDS), alignValue, OpenTime_FontSize, OpenTime_FontColor2, OpenTime_FontName, offsetX2);
         drawlabel(sTradeID+" CloseTime_N", " :", alignName, CloseTime_FontSize, CloseTime_FontColor1, CloseTime_FontName, offsetX1, OpenTime_FontSize);
         drawlabel(sTradeID+" CloseTime_V", TimeToString(OrderCloseTime(), TIME_MINUTES|TIME_SECONDS), alignValue, CloseTime_FontSize, CloseTime_FontColor2, CloseTime_FontName, offsetX2);
         drawlabel(sTradeID+" Direction_N", ":", alignName, Direction_FontSize, Direction_FontColor1, Direction_FontName, offsetX1, CloseTime_FontSize);
         drawlabel(sTradeID+" Direction_V", orderType2Str(OrderType()), alignValue, Direction_FontSize, Direction_FontColor2, Direction_FontName, offsetX2);
         drawlabel(sTradeID+" ProfitLoss_N", ":", alignName, ProfitLoss_FontSize, ProfitLoss_FontColor1, ProfitLoss_FontName, offsetX1, Direction_FontSize);
         drawlabel(sTradeID+" ProfitLoss_V", DoubleToString(OrderProfit(), 2), alignValue, ProfitLoss_FontSize, ProfitLoss_FontColor2, ProfitLoss_FontName, offsetX2);
         drawlabel(sTradeID+" TakeStopRatio_N", "/:", alignName, TakeStopRatio_FontSize, TakeStopRatio_FontColor1, TakeStopRatio_FontName, offsetX1, ProfitLoss_FontSize);
         drawlabel(sTradeID+" TakeStopRatio_V", StopExitRatio(), alignValue, TakeStopRatio_FontSize, TakeStopRatio_FontColor2, TakeStopRatio_FontName, offsetX2);
         
         drawlabel(sTradeID+" TakeStopRatio1_N", "/:", alignName, TakeStopRatio_FontSize, TakeStopRatio_FontColor1, TakeStopRatio_FontName, offsetX1, ProfitLoss_FontSize);
         drawlabel(sTradeID+" TakeStopRatio1_V", StopTakeRatio(), alignValue, TakeStopRatio_FontSize, TakeStopRatio_FontColor2, TakeStopRatio_FontName, offsetX2);
         
         datetime dt0 = OrderOpenTime(),
                  dt1 = OrderCloseTime(),
                  dtR0 = OrderOpenTime(),
                  dtR1 = OrderCloseTime();
         //  
         int a = iBarShift(Symbol(),Period(),dt0);
         int b = iBarShift(Symbol(),Period(),dt1);
         if((a-b)<TradeLinesWidth)
         {
            int shift = (TradeLinesWidth-(a-b))/2;
            dt0 = Time[fmax(0, fmin(Bars-1, a+shift))];
            dt1 = Time[fmax(0, b-shift)];
         }
         if((a-b)<TradeRectWidth)
         {
            int shift = (TradeRectWidth-(a-b))/2;
            dtR0 = Time[fmax(0, fmin(Bars-1, a+shift))];
            dtR1 = Time[fmax(0, b-shift)];
         }
         
         drawLine(sTradeID+" OpenLevel", dt0, OrderOpenPrice(),  dt1, OrderOpenPrice(), Open_Color, Open_Width, Open_Style);
         drawLine(sTradeID+" StopLevel", dt0, OrderStopLoss(),   dt1, OrderStopLoss(), Stop_Color, Stop_Width, Stop_Style);
         drawLine(sTradeID+" TakeLevel", dt0, OrderTakeProfit(), dt1, OrderTakeProfit(), Take_Color, Take_Width, Take_Style);
         drawRect(sTradeID+" TradeRect", dtR0, OrderOpenPrice(), dtR1, OrderClosePrice(), TradeRectBGColor);
      }
   }
   lastDrawnTradeID = sTradeID;
}

//+------------------------------------------------------------------+
void drawLine(string name, datetime t1, double _prc1, datetime t2, double _prc2, int clr, int width, int style)
{
   if(_prc1==0 || _prc2==0) return;
   ObjectCreate(name,OBJ_TREND,0,t1,_prc1,t2,_prc2);
   ObjectSet(name, OBJPROP_RAY, 0);
   ObjectSet(name, OBJPROP_COLOR, clr);
   ObjectSet(name, OBJPROP_STYLE, style);
   ObjectSet(name, OBJPROP_WIDTH, width);
   ObjectSet(name, OBJPROP_HIDDEN, true);
}

void drawRect(string name, datetime t1, double _prc1, datetime t2, double _prc2, int clr)
{
   ObjectCreate(name,OBJ_RECTANGLE,0,t1,_prc1,t2,_prc2);
   ObjectSet(name, OBJPROP_COLOR, clr);
   ObjectSet(name, OBJPROP_BACK, 1);
   ObjectSet(name, OBJPROP_BGCOLOR, clr);
   ObjectSet(name, OBJPROP_HIDDEN, true);
}


//       sTradeID "#12345"
void ClearTradeDetails(string sTradeID, bool isTradeID = false)
{
   for(int i=ObjectsTotal(); i>=0; i--)
   {
      string name = ObjectName(i);
      if(StringGetChar(name, 0) == '#' && StringFind(name, sTradeID) == 0){
         ObjectDelete(name);
      }
   }
}

